﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region
Sub Process_Globals
	Private smiley As Bitmap
	Private fm As FirebaseMessaging
	Type Message (Address As String, Body As String)
End Sub

Sub Service_Create
	fm.Initialize("fm")
	smiley = LoadBitmapResize(File.DirAssets, "AppIcon.png", 24dip, 24dip, False)
End Sub

Public Sub SubscribeToTopics
	'fm.SubscribeToTopic("general") 'you can subscribe to more topics
	If File.Exists(File.DirInternal, "AceBooks.txt") = True Then
		Dim Map1 As Map
		Map1 = File.ReadMap(File.DirInternal, "AceBooks.txt")
		If Map1.Size>0 Then
			Main.ID_MobileNo = 	Map1.Get("3")
		End If
	End If
	fm.SubscribeToTopic(Main.ID_MobileNo) 'you can subscribe to more topics
End Sub

Sub Service_Start (StartingIntent As Intent)
	If StartingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
		Dim messages() As  Message
		Dim MessageBody As String =""
		
		messages = ParseSmsIntent(StartingIntent)
		For i = 0 To messages.Length - 1
			Log(messages(i))
			If messages(i).Body.ToUpperCase().Contains("ACEBOOKS") Then
				MessageBody = messages(i).Body.ToUpperCase().SubString(9)
				CallSub2(Main,"SetSMSText", MessageBody )
			End If
		Next
	Else
		If StartingIntent.IsInitialized Then fm.HandleIntent(StartingIntent)
		Sleep(0)
	End If
	Service.StopAutomaticForeground 'remove if not using B4A v8+.
End Sub
Sub ParseSmsIntent (in As Intent) As Message()
	Dim messages() As Message
	If in.HasExtra("pdus") = False Then Return messages
	Dim pdus() As Object
	Dim r As Reflector
	pdus = in.GetExtra("pdus")
	If pdus.Length > 0 Then
		Dim messages(pdus.Length) As Message
		For i = 0 To pdus.Length - 1
			r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			messages(i).Body = r.RunMethod("getMessageBody")
			messages(i).Address = r.RunMethod("getOriginatingAddress")
		Next
	End If
	Return messages
End Sub

Sub fm_MessageArrived (Message As RemoteMessage)
	Log("Message arrived")
	Log($"Message data: ${Message.GetData}"$)
	Dim MsgType,AccountID,ImageID As String 
	Dim DataRcvd As String = Message.GetData.Get("body")
	Dim s() As String = Regex.Split("-", DataRcvd)
	MsgType = s(0).Trim
	AccountID = s(1).Trim
	ImageID= s(2).Trim
	Dim n As NB6
	n.Initialize("default", Application.LabelName, "DEFAULT").SmallIcon(smiley)
	Dim b As Bitmap = LoadBitmap(File.DirAssets, "logo-02.png")
	n.BigPictureStyle(b.Resize(256dip, 256dip, True), _
		b, "content title", "summary text")
	n.Color(0xFF00AEFF)
	n.Build(Message.GetData.Get("title"), Message.GetData.Get("body"), "tag", Me).Notify(7)
'	Dim n As Notification
'	n.Initialize
'	n.Icon = "icon"
'	n.SetInfo(Message.GetData.Get("title"), Message.GetData.Get("body"), Main)
'	n.Notify(1)
'	
	
	
End Sub

Sub Service_Destroy

End Sub